unit n32_unit1;
{
  cislo  32

  Adam Nemcek

  pro kresleni je pouzito OpenGL v orthografickem modu
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, opengl,
  ExtCtrls, StdCtrls, Buttons, Spin;

type zap_p = ^zap_t;
     zap_t = record
              x, y : integer;
              smer : integer;
              hrac : byte;
              used : boolean;
              dela_ctverec : boolean;
             end;


type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    GroupBox1: TGroupBox;
    BitBtn1: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    Label10: TLabel;
    SpinEdit1: TSpinEdit;
    Label11: TLabel;
    Timer1: TTimer;
    BitBtn4: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
    iPixelFormat : integer;
    rc           : hglrc;
    md           : boolean;
    procedure zapalky2pole;
    procedure zapclear;
    function  mys2polepos(x,y:integer;var xx,yy:byte):boolean;
    procedure vloz;
    procedure test_ctverec;
    function  dobry_smer(x,y:integer;smer:byte;plnytest:boolean):boolean;
    procedure test_konec;
    procedure proved_nejlepsi_tah(muzu_vlozit:boolean);
    function  testuj(x,y,smer:integer):boolean; 
    function  Najdi_sirku_X(x,y,smer:integer):zap_p;
    function  Najdi_sirku_Y(x,y,smer:integer):zap_p;
    function  dela_ctverec(zapal:zap_p;nastav:boolean):boolean;        
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses n32_unit2, n32_unit3;

{$R *.DFM}

const
 max_sirka = 10; //maximalni sirka/vyska hraciho pole

 only_onetime : boolean = true;

 nic    = 0; //4 hodnoty do pole[]
 hrac1  = 1;
 hrac2  = 2;
 ctverec= 3;

 s_n    = 0; //smery zapalek
 s_d    = 1;
 s_l    = 2;
 s_p    = 3;
 s_nic  = 5; //neplatny smer

var
 pfd : PIXELFORMATDESCRIPTOR;

 pole    : array[1..10,1..10] of byte;
 sirka_x : byte = 10;
 sirka_y : byte = 10;
 delka   : byte = 4; //delka zapalky

 akt_hrac : byte = hrac1; //aktualni hrac

 skore_1  : integer = 0; //skore
 skore_2  : integer = 0;

 zap     : tlist;
 zapvkl  : zap_t;

 posx, posy : integer; //pozice v poli (pro pohyb s klavesami)

procedure TForm1.FormCreate(Sender: TObject);
begin
 activecontrol:=nil;
 //
 zap:=tlist.create;
 zap.clear;
 zapvkl.used:=false;
 zapvkl.dela_ctverec:=false;
 //top ten hraci
 fillchar(top_hraci,sizeof(top_hraci),0);
 //inicializuj pixel format descriptor
 fillchar(pfd,sizeof(pixelformatdescriptor),0);
 pfd.nSize:=sizeof(pixelformatdescriptor);
 pfd.nVersion:=1;
 pfd.dwFlags:=	PFD_DRAW_TO_WINDOW or   PFD_SUPPORT_OPENGL or  PFD_DOUBLEBUFFER;
 pfd.iPixelType:=PFD_TYPE_RGBA;
 pfd.cColorBits:=24;
 pfd.cDepthBits:=32;
 pfd.iLayerType:=PFD_MAIN_PLANE;
 //
 iPixelFormat := ChoosePixelFormat(canvas.handle, @pfd);
// DescribePixelFormat(paintbox1.canvas.handle, iPixelFormat, sizeof(PIXELFORMATDESCRIPTOR), pfd);
 SetPixelFormat(canvas.handle, iPixelFormat, @pfd);

 //
 rc := wglCreateContext (canvas.handle);
 wglMakeCurrent (canvas.handle, rc);
 //zakladni nastaveni
 glEnable(GL_SCISSOR_TEST);
 glDisable(GL_TEXTURE_1D);
 glDisable(GL_TEXTURE_2D);
 glEnable(GL_POLYGON_SMOOTH);
 glDisable(GL_DEPTH_TEST);

 glScissor(0,0,paintbox1.width,paintbox1.height);
 glClearColor(1,1,1,1);
 wglMakeCurrent(0,0);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 //zrus rendering context
 wglMakeCurrent(0,0);
 wglDeleteContext(rc);
 zapclear;
 timer1.enabled:=false;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
 if only_onetime then
  bitbtn1.click;
 only_onetime:=false;
 if groupbox1.enabled then
  activecontrol:=groupbox1 else
  activecontrol:=nil;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
var x, y, i, sx, sy : integer;
    lx, ly, rx, ry  : integer;
begin
 //preved
 zapalky2pole;
 //kresli
 paintbox1.canvas.lock;
 wglMakeCurrent (canvas.handle, rc);
 //
// glViewport(0,paintbox1.height,paintbox1.width,paintbox1.height);
 glViewPort(0,0,paintbox1.width-1,paintbox1.height-1);
 //nastav matrixy
 glMatrixMode(GL_PROJECTION_MATRIX);
 glLoadIdentity;
 glMatrixMode(GL_MODELVIEW);
 glLoadIdentity;
 //nastav 2d mod 
 glOrtho(0,paintbox1.width-1,paintbox1.height-1,0,-1,1);
 //smaz buffery
 glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);

 glTranslate(0,0,0); //posunuti modelu = 0

 //ohraniceni
 glBegin(GL_LINE_LOOP);
  glColor4f(0,0,0,1);
  glVertex3f(0,0,0);
  glVertex3f(0,paintbox1.height-1,0);
  glVertex3f(paintbox1.width-1,paintbox1.height-1,0);
  glVertex3f(paintbox1.width-1,0,0);
 glEnd;
 //pole
 sx:=(paintbox1.width-1) div sirka_x;
 sy:=(paintbox1.height-1) div sirka_y;
 for x:=0 to sirka_x-1 do
  begin
   for y:=0 to sirka_y -1 do
    if pole[x+1,y+1]<>nic then
    begin
     glBegin(GL_QUADS);
      if pole[x+1,y+1] = ctverec then
       glColor4f(1,0.25,0,0.9) else      
      if pole[x+1,y+1] = hrac2 then
       glColor4f(0.5,0.25,0,0.9) else
       glColor4f(0.5,0.9,0.25,0.9);
      glVertex3f(x*sx,y*sy,0);
      glVertex3f((x+1)*sx,y*sy,0);
      glVertex3f((x+1)*sx,(y+1)*sy,0);
      glVertex3f(x*sx,(y+1)*sy,0);
     glEnd;
    end;
  end;
 //vkladana zapalka
// if zapvkl.used then
 begin
  //zjisti pozici, velikost
  lx:=(zapvkl.x)*sx;
  ly:=(zapvkl.y)*sy;
  rx:=lx;ry:=ly;
  case zapvkl.smer of
   s_l : begin rx:=rx - delka * sx;ry:=ry-sy;end;
   s_p : begin rx:=rx + delka * sx-sx ;lx:=lx-sx;ry:=ry-sy;end;
   s_n : begin ry:=ry - delka * sy;rx:=rx-sx;end;
   s_d : begin ry:=ry + delka * sy-sy;ly:=ly-sy;rx:=rx-sx;end;
  end;
  //kresli vklad
   glEnable(GL_BLEND);
   glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_ALPHA);
   glBegin(GL_QUADS);
    glColor4f(1,0,1,0.5);
    glVertex3f(lx,ly,0);
    glVertex3f(rx,ly,0);
    glVertex3f(rx,ry,0);
    glVertex3f(lx,ry,0);
   glEnd;
  end;
  glDisable(GL_BLEND);
 //sit
  for x:=0 to sirka_x-1 do
  begin
   for y:=0 to sirka_y -1 do
    begin
     glBegin(GL_LINES);
      glColor4f(0.0,0.0,0.0,1);
      glVertex3f(x*sx,y*sy,0);
      glVertex3f(x*sx,(y+1)*sy,0);
     glEnd;
     glBegin(GL_LINES);
      glColor4f(0.0,0.0,0,1);
      glVertex3f(x*sx,y*sy,0);
      glVertex3f((x+1)*sx,y*sy,0);
     glEnd;
    end;
  end;

 if groupbox1.enabled=false then
 begin //zesediveni
  glEnable(GL_BLEND);
  glBlendFunc(GL_ZERO, GL_SRC_ALPHA);
  glBegin(GL_POLYGON);
   glColor4f(1,1,1,0.66);
   glVertex3f(1,0,0);
   glVertex3f(paintbox1.width-2,0,0);
   glVertex3f(paintbox1.width-2,paintbox1.height-2,0);
   glVertex3f(1,paintbox1.height-2,0);
  glEnd;
  glDisable(GL_BLEND);
 end;

 glFinish;
 swapbuffers(canvas.handle); //prekresli buffer
 //konec
 wglMakeCurrent(0,0);
 paintbox1.canvas.unlock;
end;

procedure TForm1.zapclear;
var i:integer;
begin
 if zap.count>0 then
  for i:=0 to zap.count-1 do
   if assigned(zap.items[i]) then
    dispose(zap.items[i]);
 zap.clear;  
end;

procedure TForm1.zapalky2pole;
var zapal : zap_p;
    i, j  : integer;
//    x, y  : integer;
    co    : byte;
begin
 //preved pozice zapalek na pole
 fillchar(pole,10*10,0);
   if zap.count<1 then exit;
   for i:=0 to zap.count-1 do
   if assigned(zap.items[i]) then
    begin
     zapal:=zap.items[i];
     if zapal.dela_ctverec=false then
      co:=zapal.hrac else co:=ctverec;
     case zapal.smer of
      s_nic: continue;
      s_l  : for j:=1 to delka do pole[zapal.x - (j-1),zapal.y]:=co;
      s_p  : for j:=1 to delka do pole[zapal.x + (j-1),zapal.y]:=co;
      s_n  : for j:=1 to delka do pole[zapal.x,zapal.y - (j-1)]:=co;
      s_d  : for j:=1 to delka do pole[zapal.x,zapal.y + (j-1)]:=co;
     end;
    end;
end;

function  TForm1.dobry_smer(x,y:integer;smer:byte;plnytest:boolean):boolean;
var zapal : zap_p;
    i, j  : integer;
    k     : integer;
    sx,sy : integer;
    mpole : packed array[1..max_sirka] of packed record x,y:integer;end;
begin
 result:=false;
 //otestuje moznost vlozeni zapalky:
  sx:=(paintbox1.width-1) div sirka_x;
  sy:=(paintbox1.height-1) div sirka_y;
  if (x>=sirka_x*sx)or(y>=sirka_y*sy)or(x<=0)or(y<=0) then
   exit; //mys neni v poli
  case smer of
   s_nic : exit;
   s_l   : if x - delka < 0 then exit;
   s_n   : if y - delka < 0 then exit;
   s_p   : if x + delka > sirka_x+1 then exit;
   s_d   : if y + delka > sirka_y+1 then exit;
    else exit;
  end;
 //plny test -> otestuj kolize s vlozenymi zapalkami
 if (plnytest = false)or(zap.count<1) then
  begin result:=true;exit;end;

 for i:=0 to zap.count-1 do
   if assigned(zap.items[i]) then
    begin
     zapal:=zap.items[i];
     fillchar(mpole,max_sirka*sizeof(integer)*2,0);
     //test na kolizi
     case zapal.smer of
      s_nic: continue;
      s_l  : for j:=1 to delka do begin mpole[j].x:=zapal.x - (j-1);mpole[j].y:=zapal.y;end;
      s_p  : for j:=1 to delka do begin mpole[j].x:=zapal.x + (j-1);mpole[j].y:=zapal.y;end;
      s_n  : for j:=1 to delka do begin mpole[j].y:=zapal.y - (j-1);mpole[j].x:=zapal.x;end;
      s_d  : for j:=1 to delka do begin mpole[j].y:=zapal.y + (j-1);mpole[j].x:=zapal.x;end;
     end;
     //mpole ted obsahuje souradnice testovane sirky, takze ted to otestuje
     case smer of
      s_nic: continue;
      s_l  : for j:=1 to delka do
              for k:=1 to delka do
               if (mpole[j].x = x - (k-1))and(mpole[j].y=y) then exit;
      s_p  : for j:=1 to delka do
              for k:=1 to delka do
               if (mpole[j].x = x + (k-1))and(mpole[j].y=y) then exit;
      s_n  : for j:=1 to delka do
              for k:=1 to delka do
               if (mpole[j].x = x)and(mpole[j].y = y - (k-1)) then exit;
      s_d  : for j:=1 to delka do
              for k:=1 to delka do
               if (mpole[j].x = x)and(mpole[j].y = y + (k-1)) then exit;
    end;
  end;
  result:=true; //nebyla nalezena kolize
end;

function TForm1.mys2polepos(x,y:integer;var xx,yy:byte):boolean;
var sx,sy:integer;
begin
 result:=false;
 sx:=(paintbox1.width-1) div sirka_x;
 sy:=(paintbox1.height-1) div sirka_y;
 if (x>=sirka_x*sx)or(y>=sirka_y*sy)or(x<=0)or(y<=0) then
  exit; //mys neni v poli
 xx:=x div sx;inc(xx);
 yy:=y div sy;inc(yy);
 result:=true; //mys je v poli
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var i:integer;
begin
 activecontrol:=nil;
 i:=form2.showmodal;
 if (only_onetime)and(i<>mrOk) then
  begin application.terminate;end;
 if i=mrOk then
 begin
  //nova hra
  zapclear;
  akt_hrac:=hrac1;
  label8.caption:=' *** HRAJE *** ';
  paintbox1paint(nil);
  groupbox1.enabled:=true;
  sirka_x:=form2.SpinEdit1.value;
  sirka_y:=form2.SpinEdit2.value;
  skore_1:=0;
  skore_2:=0;
  label1.caption:=form2.edit1.text;
  label2.caption:='0 bodu';
  label3.caption:=form2.edit2.text;
  label4.caption:='0 bodu';
  bitbtn3.enabled:=(form2.radiobutton1.checked)or(form2.radiobutton2.checked);
  bitbtn4.enabled:=form2.radiobutton3.checked;
  if bitbtn4.enabled then
  begin
   messagebox(form1.handle,'Stiskem OK spustte hru dvou PC. Hru je mono zapausovat pomoc tlatka PAUSE.','INFO',mb_ok or mb_iconinformation);
   timer1.interval:=spinedit1.value;
   timer1.enabled:=true;
   //vloz prvni sirku
   zapvkl.x:=2;
   zapvkl.y:=2;
   zapvkl.smer:=s_d;
   vloz;
  end;
 end;
end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var xx,yy:byte;
begin
 if groupbox1.enabled=false then
  exit; //hra nezacala (jeste)
 if form2.radiobutton3.checked then
  exit;
 if (form2.radiobutton2.checked)and(akt_hrac=hrac2) then
  exit;
 if mys2polepos(x,y,xx,yy)=false then
  begin zapvkl.used:=false;exit;end else
   zapvkl.used:=true;
 //test
 if dobry_smer(xx,yy,zapvkl.smer,false) = true then
 begin//nastav
  zapvkl.x:=xx;
  zapvkl.y:=yy;
  posx:=xx;
  posy:=yy;
 end;
 paintbox1paint(nil);
end;

procedure TForm1.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 if (groupbox1.enabled=false) then
  exit; //hra nezacala (jeste)
 if form2.radiobutton3.checked then
  exit;
 if (form2.radiobutton2.checked)and(akt_hrac=hrac2) then
  exit; 
 if (button=mbLeft) then
  begin vloz;zapvkl.used:=false;end;
 if (button=mbRight)and(zapvkl.used) then
 begin
  case zapvkl.smer of
   s_nic : ;
   s_l   : if dobry_smer(zapvkl.x,zapvkl.y,s_n,false) then
            zapvkl.smer:=s_n else
           if dobry_smer(zapvkl.x,zapvkl.y,s_p,false) then
            zapvkl.smer:=s_p else
           if dobry_smer(zapvkl.x,zapvkl.y,s_d,false) then
            zapvkl.smer:=s_d else
             ;
   s_p    : if dobry_smer(zapvkl.x,zapvkl.y,s_d,false) then
            zapvkl.smer:=s_d else
           if dobry_smer(zapvkl.x,zapvkl.y,s_l,false) then
            zapvkl.smer:=s_l else
           if dobry_smer(zapvkl.x,zapvkl.y,s_n,false) then
            zapvkl.smer:=s_n else
             ;
   s_n   : if dobry_smer(zapvkl.x,zapvkl.y,s_p,false) then
            zapvkl.smer:=s_p else
           if dobry_smer(zapvkl.x,zapvkl.y,s_d,false) then
            zapvkl.smer:=s_d else
           if dobry_smer(zapvkl.x,zapvkl.y,s_l,false) then
            zapvkl.smer:=s_l else
             ;
   s_d   : if dobry_smer(zapvkl.x,zapvkl.y,s_l,false) then
            zapvkl.smer:=s_l else
           if dobry_smer(zapvkl.x,zapvkl.y,s_n,false) then
            zapvkl.smer:=s_n else
           if dobry_smer(zapvkl.x,zapvkl.y,s_p,false) then
            zapvkl.smer:=s_p else
             ;
   end;
 end;

 paintbox1paint(nil);
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if groupbox1.enabled=false then
  exit; //hra nezacala (jeste)

 if form2.radiobutton3.checked then
  exit;
 if (form2.radiobutton2.checked)and(akt_hrac=hrac2) then
  exit;

 if key=VK_RETURN then
  PaintBox1MouseUp(nil,mbLeft,[],0,0);
 if key=VK_SPACE then
  PaintBox1MouseUp(nil,mbRight,[],0,0);
 case key of
  VK_LEFT:
   if dobry_smer(posx-1,posy,zapvkl.smer,false) = true then
   begin//nastav
    dec(posx);
    zapvkl.x:=posx;
    zapvkl.y:=posy;
   end;
  VK_RIGHT:
   if dobry_smer(posx+1,posy,zapvkl.smer,false) = true then
   begin//nastav
    inc(posx);
    zapvkl.x:=posx;
    zapvkl.y:=posy;
   end;
  VK_UP:
   if dobry_smer(posx,posy-1,zapvkl.smer,false) = true then
   begin//nastav
    dec(posy);
    zapvkl.x:=posx;
    zapvkl.y:=posy;
   end;
  VK_DOWN:
   if dobry_smer(posx,posy+1,zapvkl.smer,false) = true then
   begin//nastav
    inc(posy);
    zapvkl.x:=posx;
    zapvkl.y:=posy;
   end;
 end;
 paintbox1paint(nil);
end;

procedure TForm1.vloz;
var zapalka : zap_p;
begin
 //vloz zapvkl do seznamu zapalek
 if dobry_smer(zapvkl.x,zapvkl.y,zapvkl.smer,true) = false then
  begin messagebeep($FFFFFFFF);exit;end;  //nelze vlozit !
 new(zapalka);
 move(zapvkl,zapalka^,sizeof(zap_t));
 zapalka.hrac:=akt_hrac;
 zapalka.used:=true;
 zapalka.dela_ctverec:=false;
 zap.add(zapalka);
 //inicializuj zapvkl
 zapvkl.used:=false;
 zapvkl.hrac:=akt_hrac;
 //test
  test_ctverec;
  test_konec;
 //info

 if akt_hrac = hrac1 then
  akt_hrac:=hrac2 else akt_hrac:=hrac1;

 if groupbox1.enabled then
 begin
  label8.caption:='---';
  label9.caption:='---';
  if akt_hrac=hrac1 then
   label8.caption:=' *** HRAJE *** ' else
   label9.caption:=' *** HRAJE *** ';
  //pocitac vs. hrac:
  if (akt_hrac=hrac2)and(form2.radiobutton2.checked) then
   proved_nejlepsi_tah(true);
 end;  
end;

function TForm1.Najdi_sirku_X(x,y,smer:integer):zap_p;
var zapal : zap_p;
    i     : integer;
begin //najde sirku, ktera lezi na x,y,smer
 result:=nil;
 if (smer<>s_l)and(smer<>s_p) then
  exit;
 if zap.count<1 then exit;
 for i:=0 to zap.count-1 do
 if assigned(zap.items[i]) then
  begin
   zapal:=zap.items[i];
   if (zapal.smer=s_n)or(zapal.smer=s_d)or(zapal.y<>y) then
    continue;
   if ((smer=s_l)and(zapal^.smer=s_p))or((smer=s_p)and(zapal^.smer=s_l)) then
    begin
     if smer=s_l then
      if zapal.x+delka-1 = x then
       begin result:=zapal;exit;end;
     if smer=s_p then
      if x+delka-1 = zapal.x then
       begin result:=zapal;exit;end;
    end;
   if ((smer=s_l)and(zapal^.smer=s_l))or((smer=s_p)and(zapal^.smer=s_p)) then
    begin
     if (x=zapal.x) then
      begin result:=zapal;exit;end;
    end;
  end;
end;

function TForm1.Najdi_sirku_Y(x,y,smer:integer):zap_p;
var zapal : zap_p;
    i     : integer;
begin //najde sirku, ktera lezi na x,y,smer
 result:=nil;
 if (smer<>s_n)and(smer<>s_d) then
  exit;
 if zap.count<1 then exit;
 for i:=0 to zap.count-1 do
 if assigned(zap.items[i]) then
  begin
   zapal:=zap.items[i];
   if (zapal.smer=s_l)or(zapal.smer=s_p)or(zapal.x<>x) then
    continue;
   if ((smer=s_n)and(zapal^.smer=s_d))or((smer=s_d)and(zapal^.smer=s_n)) then
    begin
     if smer=s_n then
      if zapal.y+delka-1 = y then
       begin result:=zapal;exit;end;
     if smer=s_d then
      if y+delka-1 = zapal.y then
       begin result:=zapal;exit;end;
    end;
   if ((smer=s_n)and(zapal^.smer=s_n))or((smer=s_d)and(zapal^.smer=s_d)) then
    begin
     if (y=zapal.y) then
      begin result:=zapal;exit;end;
    end;
  end;
end;


procedure TForm1.test_ctverec;
var zapal : zap_p;
    i     : integer;
begin
 if groupbox1.enabled=false then
  exit; //nehraje se
 //test - prover vsechny zapalky, ktere nemaji flag dela_ctverec nastaveny
 if zap.count<1 then exit;
 for i:=0 to zap.count-1 do
 if assigned(zap.items[i]) then
  begin
   zapal:=zap.items[i];
   dela_ctverec(zapal,true);
  end;
end;

function TForm1.dela_ctverec(zapal:zap_p;nastav:boolean):boolean;
var x1,x2    : integer;
    y1,y2    : integer;    
    s1,s2,s3 : zap_p;
begin //vrati true, jestlize je zapalka soucasti ctverce
 result:=false;
 if (zapal^.smer = s_l)or(zapal^.smer = s_p) then
 begin
  //najdi zapalky do ctverce
  if zapal^.smer = s_l then
   begin x1:=zapal^.x;x2:=zapal^.x+delka-1;end else
   begin x2:=zapal^.x;x1:=zapal^.x+delka-1;end;
  //----TEST DOLU 
  s1:=najdi_sirku_y(x1,zapal^.y+1,s_d);
  s2:=najdi_sirku_y(x2,zapal^.y+1,s_d);
  s3:=najdi_sirku_x(x1,zapal^.y+delka+1,s_l);
  if (s1<>nil)and(s2<>nil)and(s3<>nil) then
  begin
   result:=true;
   if nastav then
    begin
     if akt_hrac = hrac1 then inc(skore_1) else inc(skore_2);
      label2.caption:=inttostr(skore_1)+' bod()';
      label8.caption:=inttostr(skore_2)+' bod()';
     zapal.dela_ctverec:=true;
     s1.dela_ctverec:=true;
     s2.dela_ctverec:=true;
     s3.dela_ctverec:=true;
    end;
    exit;
   end;
   //----TEST NAHORU
  s1:=najdi_sirku_y(x1,zapal^.y-1,s_n);
  s2:=najdi_sirku_y(x2,zapal^.y-1,s_n);
  s3:=najdi_sirku_x(x1,zapal^.y-delka-1,s_l);
  if (s1<>nil)and(s2<>nil)and(s3<>nil) then
  begin
   result:=true;
   if nastav then
    begin
     if akt_hrac = hrac1 then inc(skore_1) else inc(skore_2);
      label2.caption:=inttostr(skore_1)+' bod()';
      label8.caption:=inttostr(skore_2)+' bod()';
     zapal.dela_ctverec:=true;
     s1.dela_ctverec:=true;
     s2.dela_ctverec:=true;
     s3.dela_ctverec:=true;
    end;
    exit;
   end;
 end;
 if (zapal^.smer = s_n)or(zapal^.smer = s_d) then
 begin
  //najdi zapalky do ctverce
  if zapal^.smer = s_d then
   begin y1:=zapal^.y;y2:=zapal^.y+delka-1;end else
   begin y2:=zapal^.y;y1:=zapal^.y+delka-1;end;
  //----TEST DOLEVA
  s1:=najdi_sirku_x(zapal^.x-1,y1,s_l);
  s2:=najdi_sirku_x(zapal^.x-1,y2,s_l);
  s3:=najdi_sirku_y(zapal^.x-delka-1,y1,s_d);
  if (s1<>nil)and(s2<>nil)and(s3<>nil) then
  begin
   result:=true;
   if nastav then
    begin
     if akt_hrac = hrac1 then inc(skore_1) else inc(skore_2);
      label2.caption:=inttostr(skore_1)+' bod()';
      label8.caption:=inttostr(skore_2)+' bod()';
     zapal.dela_ctverec:=true;
     s1.dela_ctverec:=true;
     s2.dela_ctverec:=true;
     s3.dela_ctverec:=true;
    end;
    exit;
   end;
  //DALSI
  s1:=najdi_sirku_x(zapal^.x,y1-1,s_l);
  s2:=najdi_sirku_x(zapal^.x,y2+1,s_l);
  s3:=najdi_sirku_y(zapal^.x-delka,y1,s_d);
  if (s1<>nil)and(s2<>nil)and(s3<>nil) then
  begin
   result:=true;
   if nastav then
    begin
     if akt_hrac = hrac1 then inc(skore_1) else inc(skore_2);
      label2.caption:=inttostr(skore_1)+' bod()';
      label8.caption:=inttostr(skore_2)+' bod()';
     zapal.dela_ctverec:=true;
     s1.dela_ctverec:=true;
     s2.dela_ctverec:=true;
     s3.dela_ctverec:=true;
    end;
    exit;
   end;
  //dalsi
  s1:=najdi_sirku_x(zapal^.x,y1-1,s_l);
  s2:=najdi_sirku_x(zapal^.x,y2+1,s_l);
  s3:=najdi_sirku_y(zapal^.x+delka,y1,s_d);
  if (s1<>nil)and(s2<>nil)and(s3<>nil) then
  begin
   result:=true;
   if nastav then
    begin
     if akt_hrac = hrac1 then inc(skore_1) else inc(skore_2);
      label2.caption:=inttostr(skore_1)+' bod()';
      label8.caption:=inttostr(skore_2)+' bod()';
     zapal.dela_ctverec:=true;
     s1.dela_ctverec:=true;
     s2.dela_ctverec:=true;
     s3.dela_ctverec:=true;
    end;
    exit;
   end;
  //----TEST DOPRAVA
  s1:=najdi_sirku_x(zapal^.x+1,y1,s_l);
  s2:=najdi_sirku_x(zapal^.x+1,y2,s_l);
  s3:=najdi_sirku_y(zapal^.x+delka+1,y1,s_d);
  if (s1<>nil)and(s2<>nil)and(s3<>nil) then
  begin
   result:=true;
   if nastav then
    begin
     if akt_hrac = hrac1 then inc(skore_1) else inc(skore_2);
      label2.caption:=inttostr(skore_1)+' bod()';
      label8.caption:=inttostr(skore_2)+' bod()';
     zapal.dela_ctverec:=true;
     s1.dela_ctverec:=true;
     s2.dela_ctverec:=true;
     s3.dela_ctverec:=true;
    end;
    exit;
   end;
 end;
end;

function TForm1.testuj(x,y,smer:integer):boolean; //true: je tam misto
var j : integer;
begin
  result:=false;
  //ma cenu testovat?
  if dobry_smer(x,y,smer,false)=false then exit;
  //prover pole
  case smer of
      s_l  : for j:=1 to delka do if pole[x - (j-1),y]<>nic then begin result:=false;exit;end;
      s_p  : for j:=1 to delka do if pole[x + (j-1),y]<>nic then begin result:=false;exit;end;
      s_n  : for j:=1 to delka do if pole[x,y - (j-1)]<>nic then begin result:=false;exit;end;
      s_d  : for j:=1 to delka do if pole[x,y + (j-1)]<>nic then begin result:=false;exit;end;
  end;
  result:=true;
end;


procedure TForm1.test_konec;
var i,x,y,bod,good_top:integer;
begin
 if groupbox1.enabled=false then
  exit; //nehraje se
 zapalky2pole;
 //pokud nenajdu misto v poli pro zapalku o velikosti delka ---> konec hry
 for x:=1 to sirka_x do
  for y:=1 to sirka_y do
   begin
    if pole[x,y]<>nic then
     continue; //nema smysl
    if (testuj(x,y,s_l))or(testuj(x,y,s_p))or
       (testuj(x,y,s_n))or(testuj(x,y,s_d)) then
        begin
         exit;
        end;
   end;
 //nenasel misto
 timer1.enabled:=false;
 messagebox(handle,'HRA JE UKONENA - PROSTOR PRO ZPALKY VYERPN','Safety Matches Game',mb_iconinformation or mb_ok);
 groupbox1.enabled:=false;
 zapvkl.used:=false;
 paintbox1paint(nil);
 //zapis hrace do .INI
 //urci viteze
 if skore_1 = skore_2 then
  messagebox(handle,'NEROZHODNY STAV!','Safety Matches Game',mb_iconinformation or mb_ok) else
 if skore_1 > skore_2 then
  begin bod:=skore_1;messagebox(handle,'Hrac cislo 1 vyhral!','Safety Matches Game',mb_iconinformation or mb_ok)end else
  begin bod:=skore_2;messagebox(handle,'Hrac cislo 2 vyhral!','Safety Matches Game',mb_iconinformation or mb_ok);end;

 //zapis top ten
 if skore_1 = skore_2 then exit;
 good_top:=1;
 for i:=1 to 10 do
 begin
  if (top_hraci[i].bodu=0) then
   continue;
  if bod > top_hraci[i].bodu then
   good_top:=i;
 end;
 if good_top>0 then
  begin //prepis
   top_hraci[good_top].bodu:=bod;
   if skore_1 > skore_2 then
    top_hraci[good_top].n:=label1.caption else
    top_hraci[good_top].n:=label2.caption;
  end;
end;

procedure TForm1.proved_nejlepsi_tah(muzu_vlozit:boolean);
var x,y: integer;
label 1;
begin
 if groupbox1.enabled=false then
  exit; //nehraje se
 zapvkl.used:=false;

 //Snaz se najit takove umisteni sirky, aby to dalo ctverec.
 for x:=1 to sirka_x do
  for y:=1 to sirka_y do
   begin
    if pole[x,y]<>nic then
     continue; //nema smysl
    if testuj(x,y,s_l) then
        begin //je tam prostor
         zapvkl.x:=x;
         zapvkl.y:=y;
         zapvkl.used:=true;
         zapvkl.smer:=s_l;

         if dela_ctverec(@zapvkl,false) then
         begin
          if muzu_vlozit then vloz;
          if muzu_vlozit then test_ctverec;
          paintbox1paint(nil);
          EXIT;
         end;
        end;
    if testuj(x,y,s_p) then
        begin //je tam prostor
         zapvkl.x:=x;
         zapvkl.y:=y;
         zapvkl.used:=true;
         zapvkl.smer:=s_p;

         if dela_ctverec(@zapvkl,false) then
         begin
          if muzu_vlozit then vloz;
          if muzu_vlozit then test_ctverec;
          paintbox1paint(nil);
          EXIT;
         end;
        end;
    if testuj(x,y,s_n) then
        begin //je tam prostor
         zapvkl.x:=x;
         zapvkl.y:=y;
         zapvkl.used:=true;
         zapvkl.smer:=s_n;

         if dela_ctverec(@zapvkl,false) then
         begin
          if muzu_vlozit then vloz;
          if muzu_vlozit then test_ctverec;
          paintbox1paint(nil);
          EXIT;
         end;
        end;
    if testuj(x,y,s_d) then
        begin //je tam prostor
         zapvkl.x:=x;
         zapvkl.y:=y;
         zapvkl.used:=true;
         zapvkl.smer:=s_d;

         if dela_ctverec(@zapvkl,false) then
         begin
          if muzu_vlozit then vloz;
          if muzu_vlozit then test_ctverec;
          paintbox1paint(nil);
          EXIT;
         end;
        end;

   end;


 //Pokud neni, pak proste vloz kamkoliv (kam to jde) sirku,
 //abys co nejvice zneprijemnil hru. (chehe)
 x:=1+random(sirka_x);
 y:=1+random(sirka_y);
    if (testuj(x,y,s_l))or(testuj(x,y,s_p))or
       (testuj(x,y,s_n))or(testuj(x,y,s_d)) then
        begin
         zapvkl.x:=x;
         zapvkl.y:=y;
         zapvkl.used:=true;
         if testuj(x,y,s_l) then zapvkl.smer:=s_l else
         if testuj(x,y,s_p) then zapvkl.smer:=s_p else
         if testuj(x,y,s_n) then zapvkl.smer:=s_n else
         if testuj(x,y,s_d) then zapvkl.smer:=s_d else
          goto 1;
         if muzu_vlozit then vloz;
         if muzu_vlozit then test_ctverec;
         paintbox1paint(nil);
         exit;
        end;
1:
 for x:=1 to sirka_x do
  for y:=1 to sirka_y do
   begin
    if pole[x,y]<>nic then
     continue; //nema smysl
    if (testuj(x,y,s_l))or(testuj(x,y,s_p))or
       (testuj(x,y,s_n))or(testuj(x,y,s_d)) then
        begin
         zapvkl.x:=x;
         zapvkl.y:=y;
         zapvkl.used:=true;
         if testuj(x,y,s_l) then zapvkl.smer:=s_l else
         if testuj(x,y,s_p) then zapvkl.smer:=s_p else
         if testuj(x,y,s_n) then zapvkl.smer:=s_n else
         if testuj(x,y,s_d) then zapvkl.smer:=s_d else
          continue;
         if muzu_vlozit then vloz;
         if muzu_vlozit then test_ctverec;
         paintbox1paint(nil);
         EXIT;
        end;
   end;
// messagebox(handle,'nenalezeno volne misto','INFO',mb_ok or mb_iconhand);
 test_konec;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
 form3.showmodal;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
 proved_nejlepsi_tah(false);
 if groupbox1.enabled then
  form1.activecontrol:=groupbox1 else
  form1.activecontrol:=nil;
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
 try timer1.interval:=spinedit1.value;except end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
 proved_nejlepsi_tah(true);
end;

end.
